package klassen_uml;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import java.awt.Font;
import java.awt.Color;

import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.text.DecimalFormat;

import javax.swing.JScrollPane;
import javax.swing.JTextArea;


public class Hauptfenster extends JFrame {
  
  /**
  * 
  */
  private static final long serialVersionUID = 8519171689153531668L;
  private JPanel contentPane;
  private DefaultComboBoxModel cbmSorte;
  private Fahrkartenautomat derRechner = new Fahrkartenautomat();
  private JTextArea taAusgabe;
  private JTextField tfMenge;
  private DecimalFormat f = new DecimalFormat("###0.00");
  
  /**
  * Launch the application.
  */
  public static void main(String[] args) {
    EventQueue.invokeLater(new Runnable() {
      public void run() {
        try {
          Hauptfenster frame = new Hauptfenster();
          frame.setVisible(true);
        } catch (Exception e) {
          e.printStackTrace();
        }
      }
    });
  }
  
  /**
  * Create the frame.
  */
  public Hauptfenster() {
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setBounds(100, 100, 552, 393);
    contentPane = new JPanel();
    contentPane.setBackground(Color.WHITE);
    contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
    setContentPane(contentPane);
    contentPane.setLayout(null);
    
    JLabel lbTitel = new JLabel("Fahrkartenautomat");
    lbTitel.setFont(new Font("Arial", Font.PLAIN, 18));
    lbTitel.setIcon(new ImageIcon(Hauptfenster.class.getResource("/klassen_uml/ic_launcher.png")));
    lbTitel.setBounds(10, 11, 293, 81);
    contentPane.add(lbTitel);
    
    JLabel lbTyp = new JLabel("Fahrkartentyp w\u00E4hlen:");
    lbTyp.setBounds(22, 168, 141, 14);
    contentPane.add(lbTyp);
    
    JComboBox cbTyp = new JComboBox();
    cbmSorte = new DefaultComboBoxModel();
    cbmSorte.addElement("Zone A");
    cbmSorte.addElement("Zone AB");
    cbmSorte.addElement("Zone ABC");
    cbmSorte.addElement("Zone ABCD");
    cbTyp.setModel(cbmSorte);
    cbTyp.setBounds(186, 165, 180, 20);
    contentPane.add(cbTyp);
  
  JButton btLeeren = new JButton("Leeren");
  btLeeren.addActionListener(new ActionListener() {
  	public void actionPerformed(ActionEvent arg0) {
  		tfMenge.setText("");	
  		taAusgabe.setText("");
  	}
  });
  btLeeren.setBounds(22, 321, 89, 23);
  contentPane.add(btLeeren);
  
  JButton btBerechne = new JButton("Berechne");
  btBerechne.addActionListener(new ActionListener() {
  	public void actionPerformed(ActionEvent arg0) {
  		//Eingabe
  		leseTyp();  		
  		leseMenge();
  		  		 		
  		//Verarbeitung
  		derRechner.ermittle_preis();
  		derRechner.berechne();
  		
  		//Ausgabe
  		schreibeErgebnis();
  	}
  });
  btBerechne.setBounds(121, 321, 113, 23);
    contentPane.add(btBerechne);
  

  
  JButton btSchliessen = new JButton("Schlie\u00DFen");
  btSchliessen.addActionListener(new ActionListener() {
  	public void actionPerformed(ActionEvent arg0) {
  		System.exit(0);
  	}
  });
  btSchliessen.setBounds(244, 321, 105, 23);
  contentPane.add(btSchliessen);
  
  JScrollPane scrollPane = new JScrollPane();
  scrollPane.setBounds(22, 219, 344, 91);
  contentPane.add(scrollPane);
  
  taAusgabe = new JTextArea();
  taAusgabe.setText("taAusgabe");
  scrollPane.setViewportView(taAusgabe);
  
  JLabel lbMenge = new JLabel("Menge:");
  lbMenge.setBounds(30, 125, 64, 14);
  contentPane.add(lbMenge);
  
  tfMenge = new JTextField();
  tfMenge.setText("tfMenge");
  tfMenge.setBounds(92, 122, 86, 20);
  contentPane.add(tfMenge);
  tfMenge.setColumns(10);
  
  JLabel lbLogo = new JLabel("");
  lbLogo.setIcon(new ImageIcon(Hauptfenster.class.getResource("/klassen_uml/logo_final.png")));
  lbLogo.setBounds(358, 312, 178, 42);
  contentPane.add(lbLogo);
  }
  
  //Hilfsmethoden und Sonstige Methoden
  
  private void leseTyp(){
		String sorte = String.valueOf(cbmSorte.getSelectedItem());
		derRechner.setTyp(sorte); 
  }
  
  private void leseMenge(){
	  int menge = Integer.parseInt(tfMenge.getText());
	  derRechner.setMenge(menge);
  }
  
  private void schreibeErgebnis(){
	  String mNewline = "\n";
		String mAusgabe = "Ermittelter Preis: "
		+f.format(derRechner.getPreis())
		+mNewline+"Gewhlter Typ: "+derRechner.getTyp()
		+mNewline+"Menge: "+derRechner.getMenge()+" Stck"
		+mNewline+"Summe insgesamt: "+ f.format(derRechner.getErgebnis());
		taAusgabe.setText(mAusgabe); 
		System.out.println(mAusgabe);
  }
}
