package klassen;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import java.awt.Font;
import java.awt.Color;

import javax.swing.JTextField;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.text.DecimalFormat;

import javax.swing.JScrollPane;
import javax.swing.JTextArea;


public class Hauptfenster extends JFrame {
  
  /**
  * 
  */
  private static final long serialVersionUID = 8519171689153531668L;
  private JPanel contentPane;
  private JTextField tfBetrag;
  private DefaultComboBoxModel cbmVon;
  private DefaultComboBoxModel cbmIn;
  private Waehrungsrechner derRechner = new Waehrungsrechner();
  private JTextArea taAusgabe;
  private DecimalFormat f = new DecimalFormat("###0.00");
  
  /**
  * Launch the application.
  */
  public static void main(String[] args) {
    EventQueue.invokeLater(new Runnable() {
      public void run() {
        try {
          Hauptfenster frame = new Hauptfenster();
          frame.setVisible(true);
        } catch (Exception e) {
          e.printStackTrace();
        }
      }
    });
  }
  
  /**
  * Create the frame.
  */
  public Hauptfenster() {
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    setBounds(100, 100, 552, 393);
    contentPane = new JPanel();
    contentPane.setBackground(Color.WHITE);
    contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
    setContentPane(contentPane);
    contentPane.setLayout(null);
    
    JLabel lbTitel = new JLabel("W\u00E4hrungsrechner");
    lbTitel.setFont(new Font("Arial", Font.PLAIN, 18));
    lbTitel.setIcon(new ImageIcon(Hauptfenster.class.getResource("/klassen/ic_launcher.png")));
    lbTitel.setBounds(10, 11, 293, 81);
    contentPane.add(lbTitel);
    
    JLabel lbBetrag = new JLabel("Betrag:");
    lbBetrag.setBounds(22, 128, 46, 14);
    contentPane.add(lbBetrag);
    
    JLabel lnVon = new JLabel("Von:");
    lnVon.setBounds(22, 168, 46, 14);
    contentPane.add(lnVon);
    
    JLabel lbIn = new JLabel("In:");
    lbIn.setBounds(22, 212, 46, 14);
    contentPane.add(lbIn);
    
    tfBetrag = new JTextField();
    tfBetrag.setText("tfBetrag");
    tfBetrag.setBounds(78, 118, 180, 27);
    contentPane.add(tfBetrag);
    tfBetrag.setColumns(10);
    
    JComboBox cbVon = new JComboBox();
    cbmVon = new DefaultComboBoxModel();
    cbmVon.addElement("Euro (EUR)");
    cbmVon.addElement("Britisches Pfund (GBP)");
    cbmVon.addElement("US Dollar (USD)");
    cbmVon.addElement("Japanischer Yen (JPY)");
    cbVon.setModel(cbmVon);
    cbVon.setBounds(78, 165, 180, 20);
    contentPane.add(cbVon);
  
    JComboBox cbIn = new JComboBox();
    cbmIn = new DefaultComboBoxModel();
    cbmIn.addElement("Euro (EUR)");
    cbmIn.addElement("Britisches Pfund (GBP)");
    cbmIn.addElement("US Dollar (USD)");
    cbmIn.addElement("Japanischer Yen (JPY)");
    cbmIn.setSelectedItem("Britisches Pfund (GBP)");
    cbIn.setModel(cbmIn);
    cbIn.setBounds(78, 209, 180, 20);
    contentPane.add(cbIn);
  
  JButton btLeeren = new JButton("Leeren");
  btLeeren.addActionListener(new ActionListener() {
  	public void actionPerformed(ActionEvent arg0) {
  		tfBetrag.setText("");
  		taAusgabe.setText("");
  	}
  });
  btLeeren.setBounds(22, 321, 89, 23);
  contentPane.add(btLeeren);
  
  JButton btUmrechnen = new JButton("Umrechnen");
  btUmrechnen.addActionListener(new ActionListener() {
  	public void actionPerformed(ActionEvent arg0) {
  		//Eingabe
  		leseVon();
  		leseIn();
  		leseBetrag();
  		
  		
  		//Verarbeitung
  		derRechner.umrechnen();
  		
  		//Ausgabe
  		schreibeErgebnis();

  	}
  });
  btUmrechnen.setBounds(121, 321, 113, 23);
    contentPane.add(btUmrechnen);
  

  
  JButton btSchliessen = new JButton("Schlie\u00DFen");
  btSchliessen.addActionListener(new ActionListener() {
  	public void actionPerformed(ActionEvent arg0) {
  		System.exit(0);
  	}
  });
  btSchliessen.setBounds(244, 321, 105, 23);
  contentPane.add(btSchliessen);
  
  JScrollPane scrollPane = new JScrollPane();
  scrollPane.setBounds(22, 248, 320, 62);
  contentPane.add(scrollPane);
  
  taAusgabe = new JTextArea();
  taAusgabe.setText("taAusgabe");
  scrollPane.setViewportView(taAusgabe);
  
  JLabel lbLogo = new JLabel("");
  lbLogo.setIcon(new ImageIcon(Hauptfenster.class.getResource("/klassen/logo_final.png")));
  lbLogo.setBounds(359, 315, 177, 39);
  contentPane.add(lbLogo);
  }
  
  private void leseVon(){
	  derRechner.setVon(String.valueOf(cbmVon.getSelectedItem()));
  }
  
  private void leseIn(){
	 derRechner.setIn(String.valueOf(cbmIn.getSelectedItem()));
  }
  
  private void leseBetrag(){
	  Double.parseDouble(tfBetrag.getText());
  }
  
  private void schreibeErgebnis(){
		String mNewline = "\n";
		String mAusgabe = "Von [Ausgangswhrung]: "
		+f.format(derRechner.getBetrag())+" "+derRechner.getVon()
		+mNewline+"In [Zielwhrung]: "
		+f.format(derRechner.getErgebnis())+" "+derRechner.getIn()
		+mNewline+"Zum Wechselkurs von: "
		+f.format(derRechner.getWechselkurs())+" "+derRechner.getVon();
		taAusgabe.setText(mAusgabe); 
		System.out.println(mAusgabe);
  }
}
